uses newdelay,crt;
type buf1 = array[0..7999] of byte;
var
  buf : ^buf1;
  bufsize : word;
  A : char;
  col,X,Y : byte;
  line : pointer;
  f : file;
  head : array[1..4] of char;
procedure writechar(X,Y : byte; ch : char);
begin
  mem[$B800 : ((Y-1)*80+(X-1))*2]:= ord(ch);
  buf^[((Y-1)*80+(X-1))*2]:= ord(ch);
end;
procedure writecolor(X,Y,col : byte);
begin
  mem[$B800 : ((Y-1)*80+(X-1))*2+1]:= col;
  buf^[((Y-1)*80+(X-1))*2+1]:= col;
end;
function getcolor(X,Y : byte): byte;
var
  col1, col2 : byte;
begin
  col1:= mem[$B800 : ((Y-1)*80+(X-1))*2+1];
  col2:= buf^[((Y-1)*80+(X-1))*2+1];
  if col1= col2 then getcolor:= col1;
end;
begin
  if paramstr(1)= '' then
    begin
      writeln;
      writeln('POUZITI: TEDIT.EXE [soubor]');
      writeln;
      writeln('Blizsi napoveda : /?');
      writeln;
      writeln('Program by Ondrej Polacek, Hippo Games 1998.');
      writeln('Naprogramovano pro Rendu.');
      halt;
    end;
  if paramstr(1)= '/?' then
    begin
      writeln;
      writeln('  Kurzor se ovlada sipkami. ');
      writeln;
      writeln('   PgUp   - Vyber barev pismenek.');
      writeln('   PgDn   - Vyber barev pismenek.');
      writeln('   Home   - Vyber barvy pozadi.');
      writeln('   End    - Vyber barvy pozadi.');
      writeln('   Insert - Blikani zapnuto/vypnuto.');
      writeln('   Esc - Konec s ulozenim.');
      writeln('   F10 - Konec bez ulozeni.');
      writeln;
      writeln('Program by Ondrej Polacek, Hippo Games 1998.');
      writeln('Naprogramovano pro Rendu.');
      halt;
    end;
  TextMode(C80+Font8x8);
  bufsize:= sizeof(buf1);
  getmem(buf,bufsize);
  line:= ptr($B800,$0);
  textattr:= 7;
  clrscr;
  assign(f,paramstr(1));
  {$I-}
  reset(f,1);
  if IOResult<>0 then move(line^,buf^,bufsize)
                 else
    begin
      blockread(f,head,4);
      if head<> 'TEXT' then
        begin
          writeln('Spatna hlavicka !');
          halt;
        end;
      blockread(f,buf^,bufsize);
      close(f);
      move(buf^,line^,bufsize);
    end;
  {$I+}
  X:= 1; Y:= 1;
  repeat
  A:= readkey;
  if A= #0 then
    begin
      A:= readkey;
      case A of
        #72 : if Y> 1 then dec(Y)
                      else Y:= 50;
        #80 : if Y< 50 then inc(Y)
                      else Y:= 1;
        #75 : if X> 1 then dec(X)
                      else X:= 80;
        #77 : if X< 80 then inc(X)
                      else X:= 1;
        #82 :
          begin
            col:= getcolor(X,Y);
            if col<128 then col:= col+128
                       else col:= col-128;
            writecolor(X,Y,col);
          end;
        #73 :
          begin
            col:= getcolor(X,Y);
            if col<256 then inc(col);
            writecolor(X,Y,col);
          end;
        #81 :
          begin
            col:= getcolor(X,Y);
            if col>0 then dec(col);
            writecolor(X,Y,col);
          end;
        #79 :
          begin
            col:= getcolor(X,Y);
            if col<113 then col:= col+16;
            writecolor(X,Y,col);
          end;
        #71 :
          begin
            col:= getcolor(X,Y);
            if col>15 then col:= col-16;
            writecolor(X,Y,col);
          end;
        #68 :
          begin
            textattr:= 7;
            clrscr;
            break;
          end;
      end;
    end
      else
        begin
          case A of
            #27 : break;
            #13 :
              begin
                inc(Y);
                X:= 1;
                if Y= 26 then Y:= 25;
              end;
            #8 :
              begin
                dec(X);
                writechar(X,Y,' ');
                if X= 0 then
                  begin
                    X:= 1;
                    if Y<> 1 then dec(Y);
                  end;
              end;
            else
              begin
{                col:= getcolor(X,Y);}
                writechar(X,Y,A);
{                write}
                inc(X);
                if X= 81 then
                  begin
                    X:= 1;
                    inc(Y);
                    if Y= 26 then Y:= 25;
                  end;
              end;
          end;
        end;
  gotoXY(X,Y);
  until A= #27;
  TextMode(C80);
  if A= #68 then halt;
  rewrite(f,1);
  head:= 'TEXT';
  blockwrite(f,head,4);
  blockwrite(f,buf^,bufsize);
  close(f);
  freemem(buf,bufsize);
  textattr:= 7;
  clrscr;
end.


